
from airflow.providers.amazon.aws.sensors.s3 import S3KeySensor

import logging

logger = logging.getLogger()

POKE_INTERVAL = 5
TIMEOUT = 60*1
VERIFY_SSL = False


def create_s3_sensor(task_id: str, connection: str, bucket: str, key: str) -> S3KeySensor:
    s3_sensor = None
    try:
        s3_sensor = S3KeySensor(
            task_id=task_id,
            bucket_key=key,
            bucket_name=bucket,
            wildcard_match=True,
            aws_conn_id=connection,
            verify=VERIFY_SSL,
            poke_interval=POKE_INTERVAL,
            timeout=TIMEOUT
        )
    except Exception as e:
        logger.error(f"Error creando Sensor S3. {e}")
    return s3_sensor
